/* Diese Funktion erzeugt Socket und bindet ihn an einen Localen Port

port:         Localer Port der gebunden werden soll
BACKLOG:      Anzahl der Maximal in der Warteschleife wartenden Verbindungen
return Value: Der FileDescriptor des Sockets

*/

#include <netinet/in.h>

int Bind(Port, BACKLOG)
  int Port;
  int BACKLOG; /* how many pending connections queue will hold */
{
  /* Socket */
  int sockfd;                    /* listen on sockfd       */
  struct sockaddr_in my_addr;    /* my address information */

  // Socket Erzeugen
  if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
    perror("socket");
    return -1;
  }
  my_addr.sin_family = AF_INET;         /* host byte order */
  my_addr.sin_port = htons(Port);       /* short, network byte order */
  my_addr.sin_addr.s_addr = INADDR_ANY; /* automatically fill with my IP */
  bzero(&(my_addr.sin_zero), 8);        /* zero the rest of the struct */
  // Socket an Localen Rechner binden
  if (bind(sockfd, (struct sockaddr *)&my_addr, sizeof(struct sockaddr)) == -1) {
    perror("bind");
    return -1;
  }
  // Listen (horchen) auf Port
  if (listen(sockfd, BACKLOG) == -1) {
    perror("listen");
    return -1;
  }
  // Socket FD als Rckgabewert
  return sockfd;
}
