// Dieses Programm verbindet die Console (Stdin/Stdout) mit einem
// Socket eines Servers

#include <stdio.h>

main(argc, argv)
  int argc;
  char *argv[];
{
  int sock; // File Descriptor des Sockets
  int fork0, fork1; // PIDs der Forks
  int BUFSIZE = 512;

  int fd_stdout = fileno(stdout);
  int fd_stdin  = fileno(stdin );


  if (argc != 3) { // nur zwei parameter + programmname
    printf("client_demo <Server> <Port>\n");
    exit(1);
  }
  // Verbindung zum Server
  if ((sock = Socket(argv[1], atoi(argv[2]))) < 0) {
    fprintf(stderr, "Can't connect to %s:%s\n", argv[1], argv[2]);
    exit(0);
  }
  // Entlosschleife zum Copieren von date von der Console/Stdin/Keyboard zum Server in einem Tochterprocess
  if (!(fork0 = fork())) {
    char buf[BUFSIZE];
    int size;

    while (1) {
      // Daten Lesen
      size = read(fd_stdin, buf, BUFSIZE); //nur fr grera datenmengen
      //	    buf[size] = 0; // gelesenden Daten Terminiren, nur ntig, wenn man die Daten als String betrachtet
      // Daten Senden
      send(sock, buf, size, 0);
    }
  }
  // Entlosschleife zum Copieren von date vom Server zur Console/Stdout/mMnitor in einem Tochterprocess
  if (!(fork1 = fork())) {
    char buf[BUFSIZE];
    int i;

    while (1) {
      // Daten Lesen vom Server
      i = recv(sock, buf, BUFSIZE, 0);
      if (i <= 0) {            // Fehler aufgetreten, exit (Warscheinlich hat der Partner die Verbindung getrennt)
	fprintf(stderr, "disconnected\n");
	kill(fork0, 15);       // Anderen Tochterprocess killen
	kill(getppid(), 15);   // Hauptprocess killen
	usleep(5);
	kill(fork0, 9);        // Nochmal mit berzeugendereren Mitteln
	kill(getppid(), 9);
	exit(0);
      }
      //	    buf[i] = 0; // gelesenden Daten Terminiren, nur ntig, wenn man die Daten als String betrachtet
      // Daten Ausgeben
      write(fd_stdout, buf, i);
    }
  }
  fprintf(stderr, "connected\n");
  // Einfach nichts tun, und warten
  while (1) {
    sleep(30);
  }
}
