// Dieses Programm verbindet die Console (Stdin/Stdout) mit einem
// Socket des Localen Rechners. Dieser kann dann einem oder mehreren
// Klienten connected werden...

#include <stdio.h>
#include <arpa/inet.h>

main(argc, argv)
  int argc;
  char *argv[];
{
  /* Socket */
  int sock, new_fd;            /* listen on sock_fd, new connection on new_fd */
  struct sockaddr_in their_addr; /* connector's address information */
  int sin_size;
  int fd_stdout = fileno(stdout);
  int fd_stdin  = fileno(stdin );
  
  int BUFSIZE = 512;

  if (argc != 2) { // nur ein parameter + programmname
    printf("server_demo <Port>\n");
    exit(1);
  }
  // Socket erzeugen und an einen Localen Port binden
  if ((sock = Bind(atoi(argv[1]), 10)) < 0) {
    fprintf(stderr, "Can't bind port %s\n", argv[1]);
    exit(1);
  }
  // Entlosschleife
  while (1) {
    /* Schalte in POLLING - Mode 
         Im normalen modus wird bei der function accept() gewartet, bis eine Verbindung eingeht.
         Mit dieser Option geht es bei accept() mit der rckgabe -1 weiter, wenn keine Verbindungen anliegen, hat gewisse vorteile, wenn das Programm noch was anderes tun soll*/
    //    fcntl(sock, F_SETFL, O_NONBLOCK);
    // Verbindung accepieren
    sin_size = sizeof(struct sockaddr_in);
    if ((new_fd = accept(sock, (struct sockaddr *)&their_addr, &sin_size)) != -1) {
      // ein Klient hat connected
      if (!fork()) {
	int fork0, i;
	// Adresse vom Rechner am anderemn Ende dieses Socket-Streams besorgen
	char *pard = inet_ntoa(their_addr.sin_addr);
	fprintf(stderr, "got connection from %s\n", pard);
	// Entlosschleife zum Copieren von date von der Console/Stdin/Keyboard zum Klieneten in einem Tochterprocess
	if (!(fork0 = fork())) {
	  char buf[BUFSIZE];

	  while (1) {
	    // Daten Lesen
	    i = read(fd_stdin, buf, BUFSIZE);
	    //	    buf[i] = 0; // gelesenden Daten Terminiren, nur ntig, wenn man die Daten als String betrachtet
	    // Daten Senden
	    send(new_fd, buf, i, 0);
	  }
	}
	// Entlosschleife zum Copieren von date vom Server zur Console/Stdout/mMnitor in einem Tochterprocess
	if (!(fork())) {
	  char buf[BUFSIZE];
	  int i;
	  
	  while (1) {
	    // Daten Lesen vom Server
	    i = recv(new_fd, buf, BUFSIZE, 0);
	    if (i <= 0) {           // Fehler aufgetreten, exit (Warscheinlich hat der Partner die Verbindung getrennt)
	      fprintf(stderr, "disconnected from %s\n", pard);
	      kill(fork0, 15);       // Anderen Tochterprocess killen
	      usleep(5);
	      kill(fork0, 9);        // Nochmal mit berzeugendereren Mitteln
	      exit(0);
	    }
	    //	    buf[i] = 0; // gelesenden Daten Terminiren, nur ntig, wenn man die Daten als String betrachtet
	    // Datan ausgeben (0: Console)
	    write(fd_stdout, buf, i);
	  }
	}
	exit(0);
      }
      close(new_fd);
    }
  }
}
