/* Dieses Programm demonstriert die verwendung eines Socket-Pairs zur
   Kommunikation zweier Prozesse */

#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <errno.h>

main()
{
  int sockets[2];
  int BUFSIZE = 512;
  char buf[BUFSIZE];
  int fd_stdin  = fileno(stdin );
  int fd_stdout = fileno(stdout);

  /* Get the socket pair */
  if (socketpair(AF_UNIX, SOCK_STREAM, 0, sockets) < 0) {
    printf("error %d on socketpair\n", errno);
    exit(1);
  }

  // FORK 0: Read from stdin and sent to socket (benutzt sockets[0])
  if (!fork()) {
    int size;
    close(sockets[1]); // Anderen Socket schlieen, sollte man tun.
    while (1) {
      // Daten Lesen
      size = read(fd_stdin, buf, BUFSIZE);
      // Daten Senden
      send(sockets[0], buf, size, 0);
    }
  }

  // FORK 1: Empfange Daten vom Socket und schreibe diese auf stdout (benutzt sockets[1])
  if (!fork()) {
    int i;
    close(sockets[0]); // Anderen Socket schlieen, sollte man tun.
    while (1) {
      // Daten Lesen vom Server
      i = recv(sockets[1], buf, BUFSIZE, 0);
      // Daten Ausgeben
      write(fd_stdout, buf, i);
    }
  }

  // Nichts tun
  while (1) {
    sleep(500);
  }

}
